import { Chunk } from "./chunk";
export declare class ChunkFacade {
    protected readonly chunk: Chunk;
    readonly id: string;
    readonly expiresAt: number;
    readonly createdAt: number;
    readonly table: string;
    readonly size: number;
    constructor(chunk: Chunk);
    loadRows(): Promise<ReturnType<typeof this.chunk.loadRows>>;
}
