"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChunkFacade = void 0;
class ChunkFacade {
    constructor(chunk) {
        this.chunk = chunk;
        this.id = this.chunk.id;
        this.table = this.chunk.table;
        this.size = this.chunk.size;
        this.expiresAt = this.chunk.expiresAt;
        this.createdAt = this.chunk.createdAt;
    }
    async loadRows() {
        return this.chunk.loadRows();
    }
}
exports.ChunkFacade = ChunkFacade;
