"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _DataWatcher_writeable;
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataWatcher = void 0;
const events_1 = __importDefault(require("events"));
class DataWatcher {
    constructor(options) {
        _DataWatcher_writeable.set(this, void 0);
        __classPrivateFieldSet(this, _DataWatcher_writeable, true, "f");
        this.$emitter = new events_1.default();
        this.$options = options;
        this.$emitter.on("block" /* WatcherEvents.Block */, () => this.$setWriteable(false));
        this.$emitter.on("unblock" /* WatcherEvents.Unblock */, () => this.$setWriteable(true));
    }
    $setWriteable(state) {
        __classPrivateFieldSet(this, _DataWatcher_writeable, state, "f");
    }
    $isWriteable() {
        return __classPrivateFieldGet(this, _DataWatcher_writeable, "f");
    }
    async $toBeUnblocked() {
        return new Promise((resolve) => this.$emitter.on("unblock" /* WatcherEvents.Unblock */, resolve));
    }
}
exports.DataWatcher = DataWatcher;
_DataWatcher_writeable = new WeakMap();
