"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScratchChunk = void 0;
const cuid_1 = __importDefault(require("cuid"));
const chunk_1 = require("./chunk");
class ScratchChunk extends chunk_1.Chunk {
    constructor(dataWatcher, scratchData) {
        const currentTimestamp = Date.now();
        super(dataWatcher, {
            id: `${scratchData.table}_${currentTimestamp}_${(0, cuid_1.default)()}`,
            size: 0,
            table: scratchData.table,
            expiresAt: currentTimestamp + scratchData.liveAtLeastMs
        });
    }
}
exports.ScratchChunk = ScratchChunk;
